
package cliente;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.sql.ResultSet;
import java.util.Scanner;
import javax.swing.JOptionPane;


public class Cliente implements Runnable {
    private Socket socket;
    
    private BufferedReader in;
    public PrintStream out;
    public String guardar;
    public String U_C;
    
    private boolean inicializado;
    private boolean executando;
    public boolean usuario_contraseña=false;
    public boolean avanzar = false;
    public boolean listo=false;
    
    public String fiscalizador;
    
    private Thread thread;
    
    public Cliente(String direccion, int puerto) throws Exception{
        inicializado = false;
        executando = false;
        
        open(direccion , puerto);
        
    }

    
    private void open(String direccion, int puerto) throws Exception {
        try{
        socket = new Socket(direccion, puerto);
        
        in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        out = new PrintStream(socket.getOutputStream());
        
        inicializado = true;
        }
        catch (Exception e){
            System.out.println(e);
            close();
            throw e;
        }
        
    }
    
    private void close(){
        if (in != null){
            try{
                in.close();                
            }
            catch (Exception e){
                System.out.println(e);
            }
        }
        
        if (out != null){
            try{
                out.close();                
            }
            catch (Exception e){
                System.out.println(e);
            }
        }
               
        if (socket != null){
            try{
                socket.close();                
            }
            catch (Exception e){
                System.out.println(e);
            }
        }
               
         in = null;
         out=null;
         socket= null;
         
         inicializado = false;
         executando = false;
                 
         thread = null;
    }
    
    
    public void start(){
        if (!inicializado || executando){
            return;
        }
        
        executando = true;
        thread = new Thread(this);
        thread.start();
        
    }
    
    public void stop() throws Exception {
        executando = false;
        
        if (thread != null){
            thread.join();
        }       
    }
    
    public boolean isEjecutando(){
        return executando;
    }
    
    public void send(String mensaje){

        out.println(mensaje);

    }
    
    public void send_DB(ResultSet set){
        out.println(set); 
    }
    
    public boolean usuario_contraseña(){
        return this.usuario_contraseña;
    }
    
    public void set_false_usuario_contraseña(){
        this.usuario_contraseña=false;
    }
    
    public boolean get_avanzar(){
        return this.avanzar;
    }
    public boolean get_listo(){
        return this.listo;
    }
    
    public void toggle_avanzar(){
        this.avanzar=false;
    }
    public void toggle_listo(){
        this.listo=false;
    }
    public String get_guardar(){
        return this.guardar;
    }
    public String get_fiscalizador(){
        return this.fiscalizador;
    }
    
        @Override
    public void run() {
        
        while (executando){
            try{
                socket.setSoTimeout(2500);
                
                String mensaje = in.readLine();
                
                if(mensaje == null){
                    break;
                }
                String[] tabla= mensaje.split("=");
                
            //    System.out.println("SHUMI: "+Schumi[1]);
                System.out.println(
                        "Mensaje enviado por servidor: "+
                         mensaje);

                if(tabla[0].equals("TABLA ")){
                    System.out.println("LISTO =TRUE");
                    this.fiscalizador=mensaje;
                    this.listo=true;
                }
                
                if(mensaje.equals("ERROR!")) 
                    JOptionPane.showMessageDialog(null, "No se encontró información!");
                 /* respuesta = "Usuario y contraseña correctos!."; */
                 /*  else respuesta = "Error Usuario / Contraseña!"; */
                if(mensaje.equals("Usuario y contraseña correctos!."))
                {
                    this.avanzar=true;
                    this.usuario_contraseña=true;
                    

                }
                else if(mensaje.equals("Error Usuario / Contraseña!"))
                {
                    this.avanzar=true;
                    this.usuario_contraseña=false;

                }
               // else this.usuario_contraseña=false;
                   /*Información guardada correctamente!"*/
                   /*"No se podido guardar la información!"*/   
                if (mensaje.equals("Información guardada correctamente!")||
                        mensaje.equals("No se podido guardar la información!"))
                {
                    this.avanzar=true;
                    this.guardar=mensaje;
                }
     
                   
               //   System.out.println(mensaje+"desde servidor!");
                
            }
            catch (SocketTimeoutException e){
                //ignorar
            }
            catch (Exception e){
                System.out.println(e);
                break;
            }
        }
        
        close();

    }
    
    
    public static void main(String[] args) throws Exception {

        System.out.println("Iniciando cliente .... ");
        System.out.println("Iniciando conexión con servidor ...");
               
        Cliente cliente = new Cliente ("localhost", 2525);

        System.out.println("Conexión establecida ...");
        String mensaje;
        cliente.start(); /*Inicia recibo datos */
        
        EnvioDatos envio = new EnvioDatos();
        Scanner scanner = new Scanner(System.in);
        
        while (true){
            System.out.print("Escriba un mensaje: ");
            mensaje = scanner.nextLine();
            
            if(!cliente.isEjecutando()){ /* Si ya no se ejecuta, termina */
                break;
            }
            
            if("AGREGAR".equals(mensaje)){
            String mensajeDB = "AGREGAR,Usuarios,Papa@Mama,aloja,Christian,Gonzalo,Atuan,Diaz,93168194,1962-07-24,2013-12-28,M";
            cliente.send(mensajeDB);
            }
            
            else if("BORRAR".equals(mensaje)){
            String mensajeDB = "BORRAR,Tabla,A_Borrar, Columna";
            cliente.send(mensajeDB);
            }
            
            else if("EDITAR".equals(mensaje)){
            String mensajeDB = "EDITAR,Tabla,Editar,Nuevo,Columna";
            cliente.send(mensajeDB);
            }
            
            else if("PASS".equals(mensaje)){
            String mensajeDB = "PASS,Usuarios,Papa@Mam,aloja";
            cliente.send(mensajeDB);
            }
            
            else if("CONSULTAR".equals(mensaje)){
            String mensajeDB = "CONSULTAR,Usuarios,PriN_Usuario,Jean";
            cliente.send(mensajeDB);
            }
            else if("CREAR".equals(mensaje)){
            String mensajeDB = "CREAR,Empresa_PRUEBA";
            cliente.send(mensajeDB);
            }
                        
            
            if ("END".equals(mensaje)){
                break;
            }
        }
        
        System.out.println("Cerrando Cliente ...");
        cliente.stop();
                
    }
    
}
















